diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/wifi-mac-queue.cc ns-3.35/src/wifi/model/wifi-mac-queue.cc
--- ns-3.34/src/wifi/model/wifi-mac-queue.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/wifi-mac-queue.cc	2021-10-01 13:26:48.000000000 -0700
@@ -62,8 +62,8 @@
   return tid;
 }
 
-WifiMacQueue::WifiMacQueue ()
-  : m_expiredPacketsPresent (false),
+WifiMacQueue::WifiMacQueue (AcIndex ac)
+  : m_ac (ac),
     NS_LOG_TEMPLATE_DEFINE ("WifiMacQueue")
 {
 }
@@ -93,21 +93,6 @@
 }
 
 bool
-WifiMacQueue::TtlExceeded (ConstIterator &it)
-{
-  if (Simulator::Now () > (*it)->GetTimeStamp () + m_maxDelay)
-    {
-      NS_LOG_DEBUG ("Removing packet that stayed in the queue for too long (" <<
-                    Simulator::Now () - (*it)->GetTimeStamp () << ")");
-      m_traceExpired (*it);
-      auto curr = it++;
-      DoRemove (curr);
-      return true;
-    }
-  return false;
-}
-
-bool
 WifiMacQueue::Enqueue (Ptr<WifiMacQueueItem> item)
 {
   NS_LOG_FUNCTION (this << *item);
@@ -138,13 +123,14 @@
 
   // the queue is full; scan the list in the attempt to remove stale packets
   ConstIterator it = begin ();
+  const Time now = Simulator::Now ();
   while (it != end ())
     {
-      if (it == pos && TtlExceeded (it))
+      if (it == pos && TtlExceeded (it, now))
         {
           return DoEnqueue (it, item);
         }
-      if (TtlExceeded (it))
+      if (TtlExceeded (it, now))
         {
           return DoEnqueue (pos, item);
         }
@@ -174,9 +160,10 @@
 WifiMacQueue::Dequeue (void)
 {
   NS_LOG_FUNCTION (this);
+  const Time now = Simulator::Now ();
   for (ConstIterator it = begin (); it != end (); )
     {
-      if (!TtlExceeded (it))
+      if (!TtlExceeded (it, now))
         {
           return DoDequeue (it);
         }
@@ -185,111 +172,33 @@
   return 0;
 }
 
-Ptr<WifiMacQueueItem>
-WifiMacQueue::DequeueByAddress (Mac48Address dest)
-{
-  NS_LOG_FUNCTION (this << dest);
-  ConstIterator it = PeekByAddress (dest);
-
-  if (it == end ())
-    {
-      return 0;
-    }
-  return Dequeue (it);
-}
-
-Ptr<WifiMacQueueItem>
-WifiMacQueue::DequeueByTid (uint8_t tid)
-{
-  NS_LOG_FUNCTION (this << +tid);
-  ConstIterator it = PeekByTid (tid);
-
-  if (it == end ())
-    {
-      return 0;
-    }
-  return Dequeue (it);
-}
-
-Ptr<WifiMacQueueItem>
-WifiMacQueue::DequeueByTidAndAddress (uint8_t tid, Mac48Address dest)
-{
-  NS_LOG_FUNCTION (this << +tid << dest);
-  ConstIterator it = PeekByTidAndAddress (tid, dest);
-
-  if (it == end ())
-    {
-      return 0;
-    }
-  return Dequeue (it);
-}
-
-Ptr<WifiMacQueueItem>
-WifiMacQueue::DequeueFirstAvailable (const Ptr<QosBlockedDestinations> blockedPackets)
-{
-  NS_LOG_FUNCTION (this);
-  ConstIterator it = PeekFirstAvailable (blockedPackets);
-
-  if (it == end ())
-    {
-      return 0;
-    }
-  return Dequeue (it);
-}
-
-Ptr<WifiMacQueueItem>
-WifiMacQueue::Dequeue (ConstIterator pos)
+void
+WifiMacQueue::DequeueIfQueued (Ptr<const WifiMacQueueItem> mpdu)
 {
-  NS_LOG_FUNCTION (this);
-
-  if (!m_expiredPacketsPresent)
-    {
-      if (TtlExceeded (pos))
-        {
-          NS_LOG_DEBUG ("Packet lifetime expired");
-          return 0;
-        }
-      return DoDequeue (pos);
-    }
+  NS_LOG_FUNCTION (this << *mpdu);
 
-  // remove stale items queued before the given position
-  ConstIterator it = begin ();
-  while (it != end ())
+  if (mpdu->IsQueued ())
     {
-      if (it == pos)
-        {
-          // reset the flag signaling the presence of expired packets before returning
-          m_expiredPacketsPresent = false;
+      NS_ASSERT (mpdu->m_queueAc == m_ac);
+      NS_ASSERT (*mpdu->m_queueIt == mpdu);
 
-          if (TtlExceeded (it))
-            {
-              return 0;
-            }
-          return DoDequeue (it);
-        }
-      else if (!TtlExceeded (it))
-        {
-          it++;
-        }
+      DoDequeue (mpdu->m_queueIt);
     }
-  NS_LOG_DEBUG ("Invalid iterator");
-  return 0;
 }
 
 Ptr<const WifiMacQueueItem>
 WifiMacQueue::Peek (void) const
 {
   NS_LOG_FUNCTION (this);
+  const Time now = Simulator::Now ();
   for (auto it = begin (); it != end (); it++)
     {
       // skip packets that stayed in the queue for too long. They will be
       // actually removed from the queue by the next call to a non-const method
-      if (Simulator::Now () <= (*it)->GetTimeStamp () + m_maxDelay)
+      if (now <= (*it)->GetTimeStamp () + m_maxDelay)
         {
           return DoPeek (it);
         }
-      // signal the presence of expired packets
-      m_expiredPacketsPresent = true;
     }
   NS_LOG_DEBUG ("The queue is empty");
   return 0;
@@ -300,11 +209,12 @@
 {
   NS_LOG_FUNCTION (this << dest);
   ConstIterator it = (pos != EMPTY ? pos : begin ());
+  const Time now = Simulator::Now ();
   while (it != end ())
     {
       // skip packets that stayed in the queue for too long. They will be
       // actually removed from the queue by the next call to a non-const method
-      if (Simulator::Now () <= (*it)->GetTimeStamp () + m_maxDelay)
+      if (now <= (*it)->GetTimeStamp () + m_maxDelay)
         {
           if (((*it)->GetHeader ().IsData () || (*it)->GetHeader ().IsQosData ())
               && (*it)->GetDestinationAddress () == dest)
@@ -312,11 +222,6 @@
               return it;
             }
         }
-      else
-        {
-          // signal the presence of expired packets
-          m_expiredPacketsPresent = true;
-        }
       it++;
     }
   NS_LOG_DEBUG ("The queue is empty");
@@ -328,22 +233,18 @@
 {
   NS_LOG_FUNCTION (this << +tid);
   ConstIterator it = (pos != EMPTY ? pos : begin ());
+  const Time now = Simulator::Now ();
   while (it != end ())
     {
       // skip packets that stayed in the queue for too long. They will be
       // actually removed from the queue by the next call to a non-const method
-      if (Simulator::Now () <= (*it)->GetTimeStamp () + m_maxDelay)
+      if (now <= (*it)->GetTimeStamp () + m_maxDelay)
         {
           if ((*it)->GetHeader ().IsQosData () && (*it)->GetHeader ().GetQosTid () == tid)
             {
               return it;
             }
         }
-      else
-        {
-          // signal the presence of expired packets
-          m_expiredPacketsPresent = true;
-        }
       it++;
     }
   NS_LOG_DEBUG ("The queue is empty");
@@ -355,11 +256,12 @@
 {
   NS_LOG_FUNCTION (this << +tid << dest);
   ConstIterator it = (pos != EMPTY ? pos : begin ());
+  const Time now = Simulator::Now ();
   while (it != end ())
     {
       // skip packets that stayed in the queue for too long. They will be
       // actually removed from the queue by the next call to a non-const method
-      if (Simulator::Now () <= (*it)->GetTimeStamp () + m_maxDelay)
+      if (now <= (*it)->GetTimeStamp () + m_maxDelay)
         {
           if ((*it)->GetHeader ().IsQosData () && (*it)->GetDestinationAddress () == dest
               && (*it)->GetHeader ().GetQosTid () == tid)
@@ -367,11 +269,6 @@
               return it;
             }
         }
-      else
-        {
-          // signal the presence of expired packets
-          m_expiredPacketsPresent = true;
-        }
       it++;
     }
   NS_LOG_DEBUG ("The queue is empty");
@@ -383,11 +280,12 @@
 {
   NS_LOG_FUNCTION (this);
   ConstIterator it = (pos != EMPTY ? pos : begin ());
+  const Time now = Simulator::Now ();
   while (it != end ())
     {
       // skip packets that stayed in the queue for too long. They will be
       // actually removed from the queue by the next call to a non-const method
-      if (Simulator::Now () <= (*it)->GetTimeStamp () + m_maxDelay)
+      if (now <= (*it)->GetTimeStamp () + m_maxDelay)
         {
           if (!(*it)->GetHeader ().IsQosData () || !blockedPackets
               || !blockedPackets->IsBlocked ((*it)->GetHeader ().GetAddr1 (), (*it)->GetHeader ().GetQosTid ()))
@@ -395,11 +293,6 @@
               return it;
             }
         }
-      else
-        {
-          // signal the presence of expired packets
-          m_expiredPacketsPresent = true;
-        }
       it++;
     }
   NS_LOG_DEBUG ("The queue is empty");
@@ -411,9 +304,10 @@
 {
   NS_LOG_FUNCTION (this);
 
+  const Time now = Simulator::Now ();
   for (ConstIterator it = begin (); it != end (); )
     {
-      if (!TtlExceeded (it))
+      if (!TtlExceeded (it, now))
         {
           return DoRemove (it);
         }
@@ -426,9 +320,11 @@
 WifiMacQueue::Remove (Ptr<const Packet> packet)
 {
   NS_LOG_FUNCTION (this << packet);
+
+  const Time now = Simulator::Now ();
   for (ConstIterator it = begin (); it != end (); )
     {
-      if (!TtlExceeded (it))
+      if (!TtlExceeded (it, now))
         {
           if ((*it)->GetPacket () == packet)
             {
@@ -455,20 +351,19 @@
       return pos;
     }
 
+  const Time now = Simulator::Now ();
+
   // remove stale items queued before the given position
   ConstIterator it = begin ();
   while (it != end ())
     {
       if (it == pos)
         {
-          // reset the flag signaling the presence of expired packets before returning
-          m_expiredPacketsPresent = false;
-
           ConstIterator curr = pos++;
           DoRemove (curr);
           return pos;
         }
-      else if (!TtlExceeded (it))
+      else if (!TtlExceeded (it, now))
         {
           it++;
         }
@@ -483,10 +378,11 @@
   NS_LOG_FUNCTION (this << dest);
 
   uint32_t nPackets = 0;
+  const Time now = Simulator::Now ();
 
   for (ConstIterator it = begin (); it != end (); )
     {
-      if (!TtlExceeded (it))
+      if (!TtlExceeded (it, now))
         {
           if ((*it)->GetHeader ().IsData () && (*it)->GetDestinationAddress () == dest)
             {
@@ -505,9 +401,11 @@
 {
   NS_LOG_FUNCTION (this << dest);
   uint32_t nPackets = 0;
+  const Time now = Simulator::Now ();
+
   for (ConstIterator it = begin (); it != end (); )
     {
-      if (!TtlExceeded (it))
+      if (!TtlExceeded (it, now))
         {
           if ((*it)->GetHeader ().IsQosData () && (*it)->GetDestinationAddress () == dest
               && (*it)->GetHeader ().GetQosTid () == tid)
@@ -526,9 +424,11 @@
 WifiMacQueue::IsEmpty (void)
 {
   NS_LOG_FUNCTION (this);
+  const Time now = Simulator::Now ();
+
   for (ConstIterator it = begin (); it != end (); )
     {
-      if (!TtlExceeded (it))
+      if (!TtlExceeded (it, now))
         {
           NS_LOG_DEBUG ("returns false");
           return false;
@@ -542,10 +442,12 @@
 WifiMacQueue::GetNPackets (void)
 {
   NS_LOG_FUNCTION (this);
+  const Time now = Simulator::Now ();
+
   // remove packets that stayed in the queue for too long
   for (ConstIterator it = begin (); it != end (); )
     {
-      if (!TtlExceeded (it))
+      if (!TtlExceeded (it, now))
         {
           it++;
         }
@@ -557,10 +459,12 @@
 WifiMacQueue::GetNBytes (void)
 {
   NS_LOG_FUNCTION (this);
+  const Time now = Simulator::Now ();
+
   // remove packets that stayed in the queue for too long
   for (ConstIterator it = begin (); it != end (); )
     {
-      if (!TtlExceeded (it))
+      if (!TtlExceeded (it, now))
         {
           it++;
         }
@@ -612,7 +516,8 @@
           m_nQueuedBytes[addressTidPair] += item->GetSize ();
         }
       // set item's information about its position in the queue
-      item->m_queueIts = {{this, ret}};
+      item->m_queueAc = m_ac;
+      item->m_queueIt = ret;
       return true;
     }
   return false;
@@ -621,6 +526,14 @@
 Ptr<WifiMacQueueItem>
 WifiMacQueue::DoDequeue (ConstIterator pos)
 {
+  NS_LOG_FUNCTION (this);
+
+  if (TtlExceeded (pos, Simulator::Now ()))
+    {
+      NS_LOG_DEBUG ("Packet lifetime expired");
+      return nullptr;
+    }
+
   Ptr<WifiMacQueueItem> item = Queue<WifiMacQueueItem>::DoDequeue (pos);
 
   if (item != 0 && item->GetHeader ().IsQosData ())
@@ -636,8 +549,8 @@
 
   if (item != 0)
     {
-      NS_ASSERT (item->m_queueIts.size () == 1);
-      item->m_queueIts.clear ();
+      NS_ASSERT (item->IsQueued ());
+      item->m_queueAc = AC_UNDEF;
     }
 
   return item;
@@ -661,8 +574,8 @@
 
   if (item != 0)
     {
-      NS_ASSERT (item->m_queueIts.size () == 1);
-      item->m_queueIts.clear ();
+      NS_ASSERT (item->IsQueued ());
+      item->m_queueAc = AC_UNDEF;
     }
 
   return item;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/wifi-mac-queue.h ns-3.35/src/wifi/model/wifi-mac-queue.h
--- ns-3.34/src/wifi/model/wifi-mac-queue.h	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/wifi-mac-queue.h	2021-10-01 13:26:48.000000000 -0700
@@ -64,7 +64,14 @@
    * \return the object TypeId
    */
   static TypeId GetTypeId (void);
-  WifiMacQueue ();
+
+  /**
+   * Constructor
+   *
+   * \param ac the Access Category of the packets stored in this queue
+   */
+  WifiMacQueue (AcIndex ac = AC_UNDEF);
+
   ~WifiMacQueue ();
 
   /// drop policy
@@ -122,61 +129,11 @@
    */
   Ptr<WifiMacQueueItem> Dequeue (void) override;
   /**
-   * Search and return, if present in the queue, the first packet (either Data
-   * frame or QoS Data frame) having the receiver address equal to <i>addr</i>.
-   * This method removes the packet from the queue.
-   * It is typically used by ns3::Txop during the CF period.
-   *
-   * \param dest the given destination
+   * Dequeue the given MPDU if it is stored in this queue.
    *
-   * \return the packet
+   * \param mpdu the given MPDU
    */
-  Ptr<WifiMacQueueItem> DequeueByAddress (Mac48Address dest);
-  /**
-   * Search and return, if present in the queue, the first packet having the
-   * TID equal to <i>tid</i>.
-   * This method removes the packet from the queue.
-   *
-   * \param tid the given TID
-   *
-   * \return the packet
-   */
-  Ptr<WifiMacQueueItem> DequeueByTid (uint8_t tid);
-  /**
-   * Search and return, if present in the queue, the first packet having the
-   * address indicated by <i>type</i> equal to <i>addr</i>, and TID
-   * equal to <i>tid</i>. This method removes the packet from the queue.
-   * It is typically used by ns3::QosTxop in order to perform correct MSDU
-   * aggregation (A-MSDU).
-   *
-   * \param tid the given TID
-   * \param dest the given destination
-   *
-   * \return the packet
-   */
-  Ptr<WifiMacQueueItem> DequeueByTidAndAddress (uint8_t tid,
-                                                Mac48Address dest);
-  /**
-   * Return first available packet for transmission. A packet could be no available
-   * if it is a QoS packet with a TID and an address1 fields equal to <i>tid</i> and <i>addr</i>
-   * respectively that index a pending agreement in the BlockAckManager object.
-   * So that packet must not be transmitted until reception of an ADDBA response frame from station
-   * addressed by <i>addr</i>. This method removes the packet from queue.
-   *
-   * \param blockedPackets the destination address & TID pairs that are waiting for a BlockAck response
-   *
-   * \return the packet
-   */
-  Ptr<WifiMacQueueItem> DequeueFirstAvailable (const Ptr<QosBlockedDestinations> blockedPackets = nullptr);
-  /**
-   * Dequeue the item at position <i>pos</i> in the queue. Return a null
-   * pointer if the given iterator is invalid, the queue is empty or the
-   * lifetime of the item pointed to by the given iterator is expired.
-   *
-   * \param pos the position of the item to be dequeued
-   * \return the dequeued item, if any
-   */
-  Ptr<WifiMacQueueItem> Dequeue (WifiMacQueue::ConstIterator pos);
+  void DequeueIfQueued (Ptr<const WifiMacQueueItem> mpdu);
   /**
    * Peek the packet in the front of the queue. The packet is not removed.
    *
@@ -327,19 +284,21 @@
    */
   uint32_t GetNBytes (void);
 
-  static const ConstIterator EMPTY;         //!< Invalid iterator to signal an empty queue
-
-
-private:
   /**
    * Remove the item pointed to by the iterator <i>it</i> if it has been in the
    * queue for too long. If the item is removed, the iterator is updated to
    * point to the item that followed the erased one.
    *
    * \param it an iterator pointing to the item
+   * \param now a copy of Simulator::Now()
    * \return true if the item is removed, false otherwise
    */
-  bool TtlExceeded (ConstIterator &it);
+  inline bool TtlExceeded (ConstIterator &it, const Time& now);
+
+  static const ConstIterator EMPTY;         //!< Invalid iterator to signal an empty queue
+
+
+private:
   /**
    * Wrapper for the DoEnqueue method provided by the base class that additionally
    * sets the iterator field of the item and updates internal statistics, if
@@ -371,7 +330,7 @@
 
   Time m_maxDelay;                          //!< Time to live for packets in the queue
   DropPolicy m_dropPolicy;                  //!< Drop behavior of queue
-  mutable bool m_expiredPacketsPresent;     //!< True if expired packets are in the queue
+  AcIndex m_ac;                             //!< the access category
 
   /// Per (MAC address, TID) pair queued packets
   std::unordered_map<WifiAddressTidPair, uint32_t, WifiAddressTidHash> m_nQueuedPackets;
@@ -384,6 +343,25 @@
   NS_LOG_TEMPLATE_DECLARE;                  //!< redefinition of the log component
 };
 
+
+/**
+ * Implementation of inline functions
+ */
+
+bool
+WifiMacQueue::TtlExceeded (ConstIterator &it, const Time& now)
+{
+  if (now > (*it)->GetTimeStamp () + m_maxDelay)
+    {
+      NS_LOG_DEBUG ("Removing packet that stayed in the queue for too long (" <<
+                    now - (*it)->GetTimeStamp () << ")");
+      auto curr = it++;
+      m_traceExpired (DoRemove (curr));
+      return true;
+    }
+  return false;
+}
+
 } //namespace ns3
 
 #endif /* WIFI_MAC_QUEUE_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/wifi-mac-queue-item.cc ns-3.35/src/wifi/model/wifi-mac-queue-item.cc
--- ns-3.34/src/wifi/model/wifi-mac-queue-item.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/wifi-mac-queue-item.cc	2021-10-01 13:26:48.000000000 -0700
@@ -41,12 +41,14 @@
 WifiMacQueueItem::WifiMacQueueItem (Ptr<const Packet> p, const WifiMacHeader & header, Time tstamp)
   : m_packet (p),
     m_header (header),
-    m_tstamp (tstamp)
+    m_tstamp (tstamp),
+    m_queueAc (AC_UNDEF)
 {
   if (header.IsQosData () && header.IsQosAmsdu ())
     {
       m_msduList = MsduAggregator::Deaggregate (p->Copy ());
     }
+  m_inFlight = false;
 }
 
 WifiMacQueueItem::~WifiMacQueueItem ()
@@ -123,7 +125,6 @@
       // An MSDU is going to be aggregated to this MPDU, hence this has to be an A-MSDU now
       Ptr<const WifiMacQueueItem> firstMsdu = Create<const WifiMacQueueItem> (*this);
       m_packet = Create<Packet> ();
-      m_queueIts.clear ();
       DoAggregate (firstMsdu);
 
       m_header.SetQosAmsdu ();
@@ -170,7 +171,6 @@
   hdr.SetLength (static_cast<uint16_t> (msdu->GetPacket ()->GetSize ()));
 
   m_msduList.push_back ({msdu->GetPacket (), hdr});
-  m_queueIts.insert (m_queueIts.end (), msdu->m_queueIts.begin (), msdu->m_queueIts.end ());
 
   // build the A-MSDU
   NS_ASSERT (m_packet);
@@ -204,13 +204,39 @@
 bool
 WifiMacQueueItem::IsQueued (void) const
 {
-  return !m_queueIts.empty ();
+  return m_queueAc != AC_UNDEF;
 }
 
-const std::list<WifiMacQueueItem::QueueIteratorPair>&
-WifiMacQueueItem::GetQueueIteratorPairs (void) const
+AcIndex
+WifiMacQueueItem::GetQueueAc (void) const
 {
-  return m_queueIts;
+  NS_ASSERT (IsQueued ());
+  return m_queueAc;
+}
+
+WifiMacQueueItem::ConstIterator
+WifiMacQueueItem::GetQueueIterator (void) const
+{
+  NS_ASSERT (IsQueued ());
+  return m_queueIt;
+}
+
+void
+WifiMacQueueItem::SetInFlight (void)
+{
+  m_inFlight = true;
+}
+
+void
+WifiMacQueueItem::ResetInFlight (void)
+{
+  m_inFlight = false;
+}
+
+bool
+WifiMacQueueItem::IsInFlight (void) const
+{
+  return m_inFlight;
 }
 
 WifiMacQueueItem::DeaggregatedMsdusCI
@@ -250,7 +276,9 @@
           os << ", ack=BlockAck";
         }
     }
-  os << ", packet=" << m_packet;
+  os << ", packet=" << m_packet
+     << ", queued=" << IsQueued ()
+     << ", inflight=" << IsInFlight ();
 }
 
 std::ostream & operator << (std::ostream &os, const WifiMacQueueItem &item)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/wifi-mac-queue-item.h ns-3.35/src/wifi/model/wifi-mac-queue-item.h
--- ns-3.34/src/wifi/model/wifi-mac-queue-item.h	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/wifi-mac-queue-item.h	2021-10-01 13:26:48.000000000 -0700
@@ -27,13 +27,13 @@
 #include "ns3/nstime.h"
 #include "wifi-mac-header.h"
 #include "amsdu-subframe-header.h"
+#include "qos-utils.h"
 #include <list>
 
 namespace ns3 {
 
 class QosBlockedDestinations;
 class Packet;
-class WifiMacQueue;
 
 /**
  * \ingroup wifi
@@ -142,12 +142,6 @@
 
   /// Const iterator typedef
   typedef std::list<Ptr<WifiMacQueueItem>>::const_iterator ConstIterator;
-  /// Information needed to remove an MSDU from the queue
-  struct QueueIteratorPair
-  {
-    WifiMacQueue* queue;  //!< pointer to the queue where the MSDU is enqueued
-    ConstIterator it;     //!< iterator pointing to the MSDU in the queue
-  };
 
   /**
    * Return true if this item is stored in some queue, false otherwise.
@@ -155,16 +149,20 @@
    * \return true if this item is stored in some queue, false otherwise
    */
   bool IsQueued (void) const;
-
   /**
-   * Get a const reference to the list of iterators pointing to the positions
-   * of the items in the queue. The list is empty if the item is not stored in
-   * a queue. The list contains multiple iterators in case of A-MSDU that is not
-   * stored in the Block Ack Manager retransmit queue.
+   * Get the AC of the queue this item is stored into. Abort if this item
+   * is not stored in a queue.
+   *
+   * \return the AC of the queue this item is stored into
+   */
+  AcIndex GetQueueAc (void) const;
+  /**
+   * Get a const iterator pointing to the position of the MPDU in the queue. This
+   * method should not be called if the MPDU is not stored in a queue.
    *
-   * \return the list of iterators pointing to the positions of the items in the queue
+   * \return an iterator pointing to the position of the MPDU in the queue
    */
-  const std::list<QueueIteratorPair>& GetQueueIteratorPairs (void) const;
+  ConstIterator GetQueueIterator (void) const;
 
   /**
    * \brief Get the MAC protocol data unit (MPDU) corresponding to this item
@@ -175,6 +173,21 @@
   Ptr<Packet> GetProtocolDataUnit (void) const;
 
   /**
+   * Mark this MPDU as being in flight (only used if Block Ack agreement established).
+   */
+  void SetInFlight (void);
+  /**
+   * Mark this MPDU as not being in flight (only used if Block Ack agreement established).
+   */
+  void ResetInFlight (void);
+  /**
+   * Return true if this MPDU is in flight, false otherwise.
+   *
+   * \return true if this MPDU is in flight, false otherwise
+   */
+  bool IsInFlight (void) const;
+
+  /**
    * \brief Print the item contents.
    * \param os output stream in which the data should be printed.
    */
@@ -189,13 +202,15 @@
    */
   void DoAggregate (Ptr<const WifiMacQueueItem> msdu);
 
-  friend class WifiMacQueue;  // to set QueueIteratorPair information
+  friend class WifiMacQueue;  // to set queue AC and iterator information
 
   Ptr<const Packet> m_packet;                   //!< The packet (MSDU or A-MSDU) contained in this queue item
   WifiMacHeader m_header;                       //!< Wifi MAC header associated with the packet
   Time m_tstamp;                                //!< timestamp when the packet arrived at the queue
   DeaggregatedMsdus m_msduList;                 //!< The list of aggregated MSDUs included in this MPDU
-  std::list<QueueIteratorPair> m_queueIts;      //!< Queue iterators pointing to this MSDU(s), if queued
+  ConstIterator m_queueIt;                      //!< Queue iterator pointing to this MPDU, if queued
+  AcIndex m_queueAc;                            //!< AC associated with the queue this MPDU is stored into
+  bool m_inFlight;                              //!< whether the MPDU is in flight
 };
 
 /**
